/*****************************************************************/
/*  Executable permettant de recuperer des cliches de la webcam  */
/*****************************************************************/
//gcc -Wall main.c -o test -l  ldmtx libcam.h libipc.h libdmtx.so qui pose pb
/** Fichiers d'inclusion **/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <getopt.h>
#include <signal.h>
#include <libwebsockets.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include <linux/serial.h>
#include <signal.h>
#include <dmtx.h>
#include "../Camera/libcam.h"
#include "../IPC/libipc.h"
#include "serial.h"

/** Constantes **/

#define QUEUE_CAPTURE	0xffbb
#define IMAGE_LARGEUR	1024
#define IMAGE_HAUTEUR	768
#define	PNG_OUTIL	"pnmtopng"
#define MODE_SERVEUR	0
#define MODE_CLIENT	1
#define	FAUX		0
#define	VRAI		1
#define MAX_CHAINE	1024
#define COMMANDE_PHOTO	"photo"
#define SERIAL_DEVICE "/dev/ttyUSB0"
#define MAX_MESSAGE 32
#define MAX_FRAME_SIZE  1024
#define WAIT_DELAY      50

/* Variables globales */

webcam_technique camera;
char valeur_datamatrix[50];
int fd;
unsigned char envoyer = 0;


static int callback_http (struct libwebsocket_context *this,
			  struct libwebsocket *wsi,enum libwebsocket_callback_reasons reason,
			  void *user,void *in,size_t len) {return 0;}

static int callback_my (struct libwebsocket_context * this,
			struct libwebsocket *wsi,enum libwebsocket_callback_reasons reason,
			void *user,void *in,size_t len)
{
  static char tampon[MAX_MESSAGE+LWS_SEND_BUFFER_PRE_PADDING+LWS_SEND_BUFFER_POST_PADDING];
  char *message=&tampon[LWS_SEND_BUFFER_PRE_PADDING];
  switch(reason)
    {
    case LWS_CALLBACK_ESTABLISHED:
      printf("connection established\n");
      // Declenchement d'un prochain envoi au navigateur
      libwebsocket_callback_on_writable(this,wsi);
      break;
    case LWS_CALLBACK_SERVER_WRITEABLE:
      // Ici sont envoyes les messages au navigateur
      if(envoyer == 1)
	{
	  strcpy(message,valeur_datamatrix);
	  libwebsocket_write(wsi,(char *)message,strlen(message),LWS_WRITE_TEXT);
	  envoyer = 0;
	}
      libwebsocket_callback_on_writable(this,wsi);
      break;
    default:
      break;
    }
  return 0;
}

static struct libwebsocket_protocols protocols[] = {
  {
    "http-only",   // name
    callback_http, // callback
    0,             // data size
    0              // maximum frame size
  },
  {"myprotocol",callback_my,0,MAX_FRAME_SIZE},
  {NULL,NULL,0,0}
};

/* Fonction principale */

void lecture()
{
  DmtxImage *img;
  DmtxDecode *dec;
  DmtxRegion *reg;
  DmtxMessage *msg;
  DmtxTime timeout;
  timeout.sec = time(NULL) + 2;
  timeout.usec = 0;
  int largeur,hauteur;
  unsigned char *image=NULL;
  valeur_datamatrix[0]='\0';
  initialisationQueue(QUEUE_CAPTURE,FAUX);
  envoyerMessage(QUEUES_COMMANDE_TYPE,COMMANDE_PHOTO,strlen(COMMANDE_PHOTO)+1);
  recevoirBinaire((char *)&largeur,sizeof(int));
  recevoirBinaire((char *)&hauteur,sizeof(int));
  if(largeur>0 && hauteur>0)
    {
      int taille=3*largeur*hauteur*sizeof(char);
      image=(unsigned char *)malloc(taille);
      recevoirBinaire((char *)image,taille);
      img = dmtxImageCreate(image,largeur,hauteur, DmtxPack24bppRGB);
      if(img != NULL)
	{
	  dec = dmtxDecodeCreate(img, 1);
	  if (dec != NULL)
	    {
	      reg = dmtxRegionFindNext(dec,&timeout);
	      if(reg != NULL)
		{
		  msg = dmtxDecodeMatrixRegion(dec, reg, DmtxUndefined);
		  if(msg != NULL)
		    {
		      strcpy(valeur_datamatrix, msg->output);
		      printf("%s \n",valeur_datamatrix);
		    }
		  dmtxMessageDestroy(&msg);
		}
	      else {printf("Datamatrix mal positionne\n");}
	      dmtxRegionDestroy(&reg);
	    }
	  dmtxDecodeDestroy(&dec);
	}
      dmtxImageDestroy(&img);
    }
}

/* Fonction principale */

int main(int argc,char *argv[])
{
  int port = 9000;
  struct lws_context_creation_info info;
  memset(&info,0,sizeof info);
  info.port=port;
  info.protocols=protocols;
  info.gid=-1;
  info.uid=-1;
  struct libwebsocket_context *context=libwebsocket_create_context(&info);
  if(context==NULL)
    {
      fprintf(stderr, "libwebsocket init failed\n");
      return -1;
    }
  int c = 0;
  //int sd = serialOpen(SERIAL_DEVICE,SERIAL_BOTH);
  char lettre;
 // serialConfig(sd,B9600);
  //if (write(sd,&c,sizeof(char)) != 1) {perror("main.write"); exit(-1);}
  action.sa_handler = hand;
  sigaction (SIGINT, &action, NULL);
  printf("starting server...\n");
  while(1)
    {
      libwebsocket_service(context,WAIT_DELAY);
      lettre=getchar();
      if (lettre == 'a')
	{
	  envoyer = 1;
	  lecture();
	}
    }
  libwebsocket_context_destroy(context);
  return 0;
}
